#ifndef __rttAiry_h__
#define __rttAiry_h__

#include<uppe_constants.h>
#include<gsl/gsl_sf_airy.h>

class rttAiry : public UPPEinitial_condition {

 public:
  namdbl maxint;
  namdbl lambda;
  namdbl tau;
  namdbl waist;
  namdbl tAiry;
  namdbl tdelay;
  namdbl R0;
  namdbl a;

  rttAiry() {
    SetName("rttAiry");
    IncludeParameter(maxint,"input_intensity");
    IncludeParameter(lambda,"wavelength");
    IncludeParameter(tau,   "pulse_duration");
    IncludeParameter(waist, "pulse_waist");
    IncludeParameter(tdelay,"time_delay"); 
    IncludeParameter(R0, "ring_radius");
    IncludeParameter(a, "apodization");
  }

  comple InitialValue(double t, double x, double y) {

    double A2SIE = 1.0/sqrt( cnst_epsilon0*cnst_c/2.0);


    return(
           sqrt( maxint.v()) * A2SIE *
           (
	   1.0e+0/(pow(0.5097e+0,2.0))*				/* Normalization to 1 for a=0.05 (^2)*/
           gsl_sf_airy_Ai(-(t-tdelay.v())/tau.v(),GSL_PREC_DOUBLE)*
           gsl_sf_airy_Ai((R0.v()-sqrt(x*x+y*y))/waist.v(),GSL_PREC_DOUBLE)*
	   exp(a.v()*(     (R0.v()-sqrt(x*x+y*y))/waist.v()))*
           exp(-a.v()*((t-tdelay.v())/tau.v()))
           +
	   1.0e+0/(pow(0.5097e+0,2.0))*
           gsl_sf_airy_Ai((t+tdelay.v())/tau.v(),GSL_PREC_DOUBLE)*
           gsl_sf_airy_Ai((R0.v()-sqrt(x*x+y*y))/waist.v(),GSL_PREC_DOUBLE)*
           exp(a.v()*(     (R0.v()-sqrt(x*x+y*y))/waist.v()))*
           exp(a.v()*((t+tdelay.v())/tau.v()))
           )*
           exp(comple(0.0, -t*2.0*M_PI*cnst_c/lambda.v()))
           );
           

  }
};


#endif // __rtAiry_h__
