#ifndef __tAiryL_h__
#define __tAiryL_h__

#include<uppe_constants.h>
#include<gsl/gsl_sf_airy.h>

class tAiryL : public UPPEinitial_condition {

 public:
  namdbl maxint;
  namdbl lambda;
  namdbl tau;
  namdbl waist;
  namdbl tdelay;
  namdbl a;

  tAiryL() {
    SetName("tAiryL");
    IncludeParameter(maxint,"input_intensity");
    IncludeParameter(lambda,"wavelength");
    IncludeParameter(tau,   "pulse_duration");
    IncludeParameter(waist, "pulse_waist");
    IncludeParameter(tdelay,"time_delay"); 
    IncludeParameter(a, "apodization");
  }

  comple InitialValue(double t, double x, double y) {

    double A2SIE = 1.0/sqrt( cnst_epsilon0*cnst_c/2.0);

    return(
           sqrt( maxint.v()) * A2SIE *
           (
           -1.0/0.5097e+0*
           gsl_sf_airy_Ai((t+tdelay.v())/tau.v(),GSL_PREC_DOUBLE)*
           exp(a.v()*((t+tdelay.v())/tau.v()))*
           exp(-(x*x+y*y)/pow(waist.v(),2.0) )
           )*
           exp(comple(0.0, -t*2.0*M_PI*cnst_c/lambda.v()))
           );
           

  }
};


#endif // __rtAiry_h__
